# Table of contents

- [Introduction](Introduction.md)

## Walkthroughs

- [Installing Slate](walkthroughs/01-installing-slate.md)
- [Adding Event Handlers](walkthroughs/02-adding-event-handlers.md)
- [Defining Custom Elements](walkthroughs/03-defining-custom-elements.md)
- [Applying Custom Formatting](walkthroughs/04-applying-custom-formatting.md)
- [Executing Commands](walkthroughs/05-executing-commands.md)
- [Saving to a Database](walkthroughs/06-saving-to-a-database.md)
- [Using the Bundled Source](walkthroughs/xx-using-the-bundled-source.md)

## Concepts

- [Interfaces](concepts/01-interfaces.md)
- [Nodes](concepts/02-nodes.md)
- [Locations](concepts/03-locations.md)
- [Commands](concepts/04-commands.md)
- [Operations](concepts/05-operations.md)
- [Editor](concepts/06-editor.md)
- [Plugins](concepts/07-plugins.md)
- [Rendering](concepts/08-rendering.md)
- [Serializing](concepts/09-serializing.md)
- [Normalizing](concepts/10-normalizing.md)
- [TypeScript](concepts/11-typescript.md)
- [Migrating](concepts/xx-migrating.md)

## API

- [Transforms](api/transforms.md)
- [Node Types](api/nodes/README.md)
  - [Editor](api/nodes/editor.md)
  - [Element](api/nodes/element.md)
  - [Node](api/nodes/node.md)
  - [Text](api/nodes/text.md)
- [Location Types](api/locations/README.md)
  - [Location](api/locations/location.md)
  - [Path](api/locations/path.md)
  - [Point](api/locations/point.md)
  - [PointRef](api/locations/point-ref.md)
  - [Range](api/locations/range.md)
  - [RangeRef](api/locations/range-ref.md)
- [Operation](api/operation.md)

## Libraries

- [Slate React](libraries/slate-react.md)
- [Slate History](libraries/slate-history.md)
- [Slate Hyperscript](libraries/slate-hyperscript.md)

## General

- [Resources](general/resources.md)
- [Contributing](general/contributing.md)
- [Changelog](general/changelog.md)
- [FAQ](general/faq.md)
